
// Input pins for ch1~ch3
int pin_ch1 = 4;  // Left Right Channel
int pin_ch2 = 7;  // Thottle Channel
int pin_ch3 = 8; //ON OfF Channel

// Output pins for LEDs
int Head_LED = 3;   // use PWM Output
int Turn_L_LED = 5;   // use PWM Output
int Turn_R_LED = 6;   // use PWM Output
int Break_LED = 9;    // use PWM Output
int Back_LED = 10;     // use PWM Output
int Room_LED = 11;     // use PWM Output
int Backfire_LED = 12;      // use Digital Output , because all PWM used

// Set Brightness of LEDs 0~255
int Head_LED_Brightness_Max = 255; 
int Turn_L_LED_Brightness_Max = 255;
int Turn_R_LED_Brightness_Max = 255;
int Break_LED_Brightness_Max = 255;
int Back_LED_Brightness_Max = 255;
int Room_LED_Brightness_Max = 255;

boolean ch1_invert = false;  //  Turn signal Channel 1 invertor , invert then "true"
boolean ch2_invert = true;  // Throttle Channel 2 invertor , invert then "true"
boolean ch3_invert = false;  // on off switch Channel 3 invertor , invert then "true"

// Left Right Signal Range define
int L_Value = 1400;   // L < 1400
int R_Value = 1600;   // R > 1600

int Interval_Turn_Signal = 200 ;

byte ON = 1;
byte OFF = 0;

// read channel values ch1 ch2 ch3 1000~2000 ns 
int ch1;
int ch2;
int ch3;

int Head_LED_Brightness; 
int Turn_L_LED_Brightness;
int Turn_R_LED_Brightness;
int Break_LED_Brightness;
int Back_LED_Brightness;
int Room_LED_Brightness;
int Backfire_LED_ON_OFF = HIGH;
boolean Forward;
boolean Backward;
boolean Break;
boolean Left;
boolean Right;
boolean After_Forward;

// Timers
byte Timer_Turn = OFF ;
byte Timer_Break = OFF ;
unsigned long Timer_Turn_Previous = 0;
unsigned long Timer_Turn_Current = 0;
unsigned long Timer_Turn_Interval = 0;
unsigned long Timer_Break_Previous = 0;
unsigned long Timer_Break_Current = 0;
unsigned long Timer_Break_Interval = 0;

void setup() {

  pinMode(pin_ch1, INPUT); // Set our input pins as such - Channel 1
  pinMode(pin_ch2, INPUT); // Channel 2
  pinMode(pin_ch3, INPUT); // Channel 3
  
  pinMode(Head_LED, OUTPUT);
  pinMode(Turn_L_LED, OUTPUT);
  pinMode(Turn_R_LED, OUTPUT);
  pinMode(Break_LED, OUTPUT);
  pinMode(Back_LED, OUTPUT);
  pinMode(Backfire_LED, OUTPUT);
 
 // Serial.begin(9600); // Pour a bowl of Serial
}

// -------------  Start Loop -------------------

void loop() {

  readreceiver();

// -------   Calculate the LEDs brightness  -------

  if (ch3 < 1500) {        //  Check Channel3 On Off switch
    
      Head_LED_Brightness = 0 ;
      Turn_L_LED_Brightness = 0; 
      Turn_R_LED_Brightness = 0; 
      Break_LED_Brightness = 0;
      Back_LED_Brightness = 0;
      Room_LED_Brightness = 0;
      Backfire_LED_ON_OFF = LOW ;
      Timer_Break = OFF ;
      Timer_Break_Previous = 0;
      Timer_Break_Current = 0;
  } 
  else  {
 
 // ----- Check Throttle Channel 2 ----- 
     // Check action
        if (ch2 > 1700) {Forward=true; Backward=false; Break=false; After_Forward=true;}
        if (ch2 < 1400) {Backward=true; Forward=false; Break=false; After_Forward=false;}
        if (ch2 > 1400 && ch2 < 1700) {
          Break=true; Backward=false; Forward=false; 
          Timer_Break_Current = millis();
          if (Timer_Break == OFF) {
           Timer_Break = ON ;
           Timer_Break_Previous = millis();
           }
           Timer_Break_Interval = Timer_Break_Current - Timer_Break_Previous;
      } else {
          Break_LED_Brightness = Break_LED_Brightness_Max/4;
          Timer_Break = OFF ;
          Timer_Break_Previous = 0;
          Timer_Break_Current = 0;
          Timer_Break_Interval = 0;
       }
       

     // Head Ligh Action
     
      if (Break && Timer_Break_Interval > 12000) {
        Head_LED_Brightness = Head_LED_Brightness_Max / 4 ;
      } else {
        Head_LED_Brightness = Head_LED_Brightness_Max ;
      }
     

      // Break Ligh Action
      if (Break && Timer_Break_Interval < 500) {
        Break_LED_Brightness = Break_LED_Brightness_Max ;
      } else {
        Break_LED_Brightness = Break_LED_Brightness_Max/4 ;
      }
      
       
      // Back Light Action
      if (Backward) {
        Back_LED_Brightness = Back_LED_Brightness_Max;
      } else {
        if (Back_LED_Brightness > 50) { Back_LED_Brightness = Back_LED_Brightness - 50 ; } else { Back_LED_Brightness = 0; }  //fade out
      }

      // Room Light Action
      
    if (Break && Timer_Break_Interval > 10000) {
            Room_LED_Brightness = Room_LED_Brightness_Max;
     } else {
            if (Room_LED_Brightness > 10) { Room_LED_Brightness = Room_LED_Brightness - 10 ; } else { Room_LED_Brightness = 0; }  //fade out
      }
    
      // Backfire Light Action
     
      if (Break && After_Forward && Timer_Break_Interval > 200 && Timer_Break_Interval < 500) {
          if (random(100) < 25) {
            Backfire_LED_ON_OFF = HIGH ;
          } else {
            Backfire_LED_ON_OFF = LOW ;
          }
      } else {
        Backfire_LED_ON_OFF = LOW ;
      }
    

// ----- Check Turn Signal Channel 1 -----

    // Check Turn Signal
        if (ch1 < L_Value) {Left=true; Right=false;}
        if (ch1 > R_Value) {Right=true; Left=false;}
        if (ch1 < R_Value && ch1 > L_Value) {
          Right=false; Left=false;
          Timer_Turn = OFF ;
        } else {
            if (Timer_Turn == OFF) {
            Timer_Turn = ON ;
            Timer_Turn_Previous = millis();
            }

            Timer_Turn_Current = millis();
            Timer_Turn_Interval = Timer_Turn_Current - Timer_Turn_Previous;
        }
        
      // --- Turn Left ---
      if (Left) {
          if ( (Timer_Turn_Interval/Interval_Turn_Signal) % 2) {
            if (Turn_L_LED_Brightness > 80) { Turn_L_LED_Brightness = Turn_L_LED_Brightness - 80 ; } else { Turn_L_LED_Brightness = 0; }  //fade out
          } else {
            Turn_L_LED_Brightness = Turn_L_LED_Brightness_Max;   
          }
          if (Turn_R_LED_Brightness > 80) { Turn_R_LED_Brightness = Turn_R_LED_Brightness - 80 ; } else { Turn_R_LED_Brightness = 0; }  //fade out
     }


      // --- Turn Right ---
      if (Right) {
           if ( (Timer_Turn_Interval/Interval_Turn_Signal) % 2) {
           if (Turn_R_LED_Brightness > 80) { Turn_R_LED_Brightness = Turn_R_LED_Brightness - 80 ; } else { Turn_R_LED_Brightness = 0; }  //fade out
          } else {
            Turn_R_LED_Brightness = Turn_R_LED_Brightness_Max;  
          }
          if (Turn_L_LED_Brightness > 80) { Turn_L_LED_Brightness = Turn_L_LED_Brightness - 80 ; } else { Turn_L_LED_Brightness = 0; }  //fade out
      }

      // --- Centre Posistion ---
      if (!Left && !Right ) {
          if (Turn_L_LED_Brightness > 80) { Turn_L_LED_Brightness = Turn_L_LED_Brightness - 80 ; } else { Turn_L_LED_Brightness = 0; }  //fade out
          if (Turn_R_LED_Brightness > 80) { Turn_R_LED_Brightness = Turn_R_LED_Brightness - 80 ; } else { Turn_R_LED_Brightness = 0; }  //fade out
      }
      

      
    }



 /* Debug Code to check channel signal
  Serial.print("Channel 1:"); // Print the value of 
  Serial.println(ch1);        // each channel
  Serial.print("Channel 2:");
  Serial.println(ch2);
  Serial.print("Channel 3:");
  Serial.println(ch3);
  delay(200);
  */
  updateLEDs();

}

void readreceiver() {
  ch1 = pulseIn(pin_ch1, HIGH); // Read the pulse width of 
  ch2 = pulseIn(pin_ch2, HIGH); // each channel
  ch3 = pulseIn(pin_ch3, HIGH);
  if (ch1_invert) { ch1 = 1500-(ch1-1500); }
  if (ch2_invert) { ch2 = 1500-(ch2-1500); }
  if (ch3_invert) { ch3 = 1500-(ch3-1500); }
  
}

void updateLEDs()
{
  analogWrite(Head_LED, Head_LED_Brightness);
  analogWrite(Turn_L_LED, Turn_L_LED_Brightness);
  analogWrite(Turn_R_LED, Turn_R_LED_Brightness);
  analogWrite(Break_LED, Break_LED_Brightness);
  analogWrite(Back_LED, Back_LED_Brightness);
  analogWrite(Room_LED, Room_LED_Brightness);
  digitalWrite(Backfire_LED, Backfire_LED_ON_OFF);
}

